# SwaggerClient::JobDetailsApi

All URIs are relative to *https://service.fax-api.de/4.0/rest*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_job**](JobDetailsApi.md#get_job) | **GET** /jobs/{id} | /jobs/{id}
[**get_job_notifications**](JobDetailsApi.md#get_job_notifications) | **GET** /jobs/{id}/notifications | /jobs/{id}/notifications
[**get_job_previews**](JobDetailsApi.md#get_job_previews) | **GET** /jobs/{id}/preview | /jobs/{id}/preview
[**get_job_recipients**](JobDetailsApi.md#get_job_recipients) | **GET** /jobs/{id}/recipients | /jobs/{id}/recipients
[**get_job_templates**](JobDetailsApi.md#get_job_templates) | **GET** /jobs/{id}/templates | /jobs/{id}/templates
[**put_job**](JobDetailsApi.md#put_job) | **PUT** /jobs/{id} | /jobs/{id}

# **get_job**
> Job get_job(id)

/jobs/{id}

Description: Obtain information of a specific job

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobDetailsApi.new
id = 'id_example' # String | Identification number (UUID) of the job


begin
  #/jobs/{id}
  result = api_instance.get_job(id)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobDetailsApi->get_job: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Identification number (UUID) of the job | 

### Return type

[**Job**](Job.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_job_notifications**
> Notifications get_job_notifications(id)

/jobs/{id}/notifications

Description: To obtain a list of notifications to a specific job

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobDetailsApi.new
id = 'id_example' # String | Identification number (UUID) of the job


begin
  #/jobs/{id}/notifications
  result = api_instance.get_job_notifications(id)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobDetailsApi->get_job_notifications: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Identification number (UUID) of the job | 

### Return type

[**Notifications**](Notifications.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_job_previews**
> Preview get_job_previews(id)

/jobs/{id}/preview

Description: To obtain the preview pdf document of a specific job

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobDetailsApi.new
id = 'id_example' # String | Identification number (UUID) of the job


begin
  #/jobs/{id}/preview
  result = api_instance.get_job_previews(id)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobDetailsApi->get_job_previews: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Identification number (UUID) of the job | 

### Return type

[**Preview**](Preview.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_job_recipients**
> JobRecipients get_job_recipients(id, opts)

/jobs/{id}/recipients

Description: Resource to obtain a list of recipients to a specific job

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobDetailsApi.new
id = 'id_example' # String | Identification number (UUID) of the job
opts = { 
  object_limit: 100, # Integer | Query parameter to change de default limitation of objects in the result data array
  object_offset: 0, # Integer | Query parameter to change de default offset of objects in the result data array
  filter_fax_number: 'filter_fax_number_example', # String | Query parameter to fetch recipients after his fax number
  filter_fax_number_norm: 'filter_fax_number_norm_example', # String | Query parameter to fetch recipients after his normed fax number
  filter_recipient_reference: 'filter_recipient_reference_example', # String | Query parameter to fetch recipients after his recipient reference
  filter_international_dialing_code: 'filter_international_dialing_code_example', # String | Query parameter to fetch recipients after his international dialing code
  filter_result_code: 'filter_result_code_example', # String | Query parameter to fetch recipients after his result code
  filter_result_text: 'filter_result_text_example', # String | Query parameter to fetch recipients after his result text
  sort_field: 'sort_field_example', # String | Available sort options for the result data array.
  sort_order: 'asc' # String | Describes the order for used sort fields
}

begin
  #/jobs/{id}/recipients
  result = api_instance.get_job_recipients(id, opts)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobDetailsApi->get_job_recipients: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Identification number (UUID) of the job | 
 **object_limit** | **Integer**| Query parameter to change de default limitation of objects in the result data array | [optional] [default to 100]
 **object_offset** | **Integer**| Query parameter to change de default offset of objects in the result data array | [optional] [default to 0]
 **filter_fax_number** | **String**| Query parameter to fetch recipients after his fax number | [optional] 
 **filter_fax_number_norm** | **String**| Query parameter to fetch recipients after his normed fax number | [optional] 
 **filter_recipient_reference** | **String**| Query parameter to fetch recipients after his recipient reference | [optional] 
 **filter_international_dialing_code** | **String**| Query parameter to fetch recipients after his international dialing code | [optional] 
 **filter_result_code** | **String**| Query parameter to fetch recipients after his result code | [optional] 
 **filter_result_text** | **String**| Query parameter to fetch recipients after his result text | [optional] 
 **sort_field** | **String**| Available sort options for the result data array. | [optional] 
 **sort_order** | **String**| Describes the order for used sort fields | [optional] [default to asc]

### Return type

[**JobRecipients**](JobRecipients.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **get_job_templates**
> Templates get_job_templates(id)

/jobs/{id}/templates

Description: To obtain a list of template documents to a specific job

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobDetailsApi.new
id = 'id_example' # String | Identification number (UUID) of the job


begin
  #/jobs/{id}/templates
  result = api_instance.get_job_templates(id)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobDetailsApi->get_job_templates: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| Identification number (UUID) of the job | 

### Return type

[**Templates**](Templates.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json



# **put_job**
> Job put_job(bodyid)

/jobs/{id}

Description: Control the transmission of the specific job

### Example
```ruby
# load the gem
require 'swagger_client'
# setup authorization
SwaggerClient.configure do |config|
  # Configure API key authorization: ApiAuthKey
  config.api_key['X-Auth-Token'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  #config.api_key_prefix['X-Auth-Token'] = 'Bearer'
end

api_instance = SwaggerClient::JobDetailsApi.new
body = SwaggerClient::JobsIdBody.new # JobsIdBody | Describes the required request body to perform an action on the fax job
id = 'id_example' # String | Identification number (UUID) of the job


begin
  #/jobs/{id}
  result = api_instance.put_job(bodyid)
  p result
rescue SwaggerClient::ApiError => e
  puts "Exception when calling JobDetailsApi->put_job: #{e}"
end
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**JobsIdBody**](JobsIdBody.md)| Describes the required request body to perform an action on the fax job | 
 **id** | **String**| Identification number (UUID) of the job | 

### Return type

[**Job**](Job.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json



