=begin
#Faxsuite RESTful API

#<p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  

OpenAPI spec version: 4.0.0
Contact: support@fax-api.de
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.35
=end

module SwaggerClient
  class RecipientsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # /recipients
    # Description: To obtain a list of recipients
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :object_limit Query parameter to change de default limitation of objects in the result data array (default to 100)
    # @option opts [Integer] :object_offset Query parameter to change de default offset of objects in the result data array (default to 0)
    # @option opts [String] :filter_job_id Query parameter to fetch after recipient related to specific fax job
    # @option opts [BOOLEAN] :filter_same_account Query parameter to fetch recipient related to jobs linked to the used token/key for authorization (default to false)
    # @option opts [String] :filter_fax_number Query parameter to fetch recipients after his fax number
    # @option opts [String] :filter_fax_number_norm Query parameter to fetch recipients after his normed fax number
    # @option opts [String] :filter_recipient_reference Query parameter to fetch recipients after his recipient reference
    # @option opts [String] :filter_international_dialing_code Query parameter to fetch recipients after his international dialing code
    # @option opts [String] :filter_result_code Query parameter to fetch recipients after his result code
    # @option opts [String] :filter_result_text Query parameter to fetch recipients after his result text
    # @option opts [String] :sort_field Available sort options for the result data array.
    # @option opts [String] :sort_order Describes the order for used sort fields (default to asc)
    # @return [Recipients]
    def get_recipients(opts = {})
      data, _status_code, _headers = get_recipients_with_http_info(opts)
      data
    end

    # /recipients
    # Description: To obtain a list of recipients
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :object_limit Query parameter to change de default limitation of objects in the result data array
    # @option opts [Integer] :object_offset Query parameter to change de default offset of objects in the result data array
    # @option opts [String] :filter_job_id Query parameter to fetch after recipient related to specific fax job
    # @option opts [BOOLEAN] :filter_same_account Query parameter to fetch recipient related to jobs linked to the used token/key for authorization
    # @option opts [String] :filter_fax_number Query parameter to fetch recipients after his fax number
    # @option opts [String] :filter_fax_number_norm Query parameter to fetch recipients after his normed fax number
    # @option opts [String] :filter_recipient_reference Query parameter to fetch recipients after his recipient reference
    # @option opts [String] :filter_international_dialing_code Query parameter to fetch recipients after his international dialing code
    # @option opts [String] :filter_result_code Query parameter to fetch recipients after his result code
    # @option opts [String] :filter_result_text Query parameter to fetch recipients after his result text
    # @option opts [String] :sort_field Available sort options for the result data array.
    # @option opts [String] :sort_order Describes the order for used sort fields
    # @return [Array<(Recipients, Integer, Hash)>] Recipients data, response status code and response headers
    def get_recipients_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RecipientsApi.get_recipients ...'
      end
      if @api_client.config.client_side_validation && opts[:'sort_field'] && !['jobId', 'faxNumber', 'faxNumberNorm', 'internationalDialingCode', 'recipientReference', 'fareZone', 'senderTime'].include?(opts[:'sort_field'])
        fail ArgumentError, 'invalid value for "sort_field", must be one of jobId, faxNumber, faxNumberNorm, internationalDialingCode, recipientReference, fareZone, senderTime'
      end
      if @api_client.config.client_side_validation && opts[:'sort_order'] && !['asc', 'desc'].include?(opts[:'sort_order'])
        fail ArgumentError, 'invalid value for "sort_order", must be one of asc, desc'
      end
      # resource path
      local_var_path = '/recipients'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'objectLimit'] = opts[:'object_limit'] if !opts[:'object_limit'].nil?
      query_params[:'objectOffset'] = opts[:'object_offset'] if !opts[:'object_offset'].nil?
      query_params[:'filterJobId'] = opts[:'filter_job_id'] if !opts[:'filter_job_id'].nil?
      query_params[:'filterSameAccount'] = opts[:'filter_same_account'] if !opts[:'filter_same_account'].nil?
      query_params[:'filterFaxNumber'] = opts[:'filter_fax_number'] if !opts[:'filter_fax_number'].nil?
      query_params[:'filterFaxNumberNorm'] = opts[:'filter_fax_number_norm'] if !opts[:'filter_fax_number_norm'].nil?
      query_params[:'filterRecipientReference'] = opts[:'filter_recipient_reference'] if !opts[:'filter_recipient_reference'].nil?
      query_params[:'filterInternationalDialingCode'] = opts[:'filter_international_dialing_code'] if !opts[:'filter_international_dialing_code'].nil?
      query_params[:'filterResultCode'] = opts[:'filter_result_code'] if !opts[:'filter_result_code'].nil?
      query_params[:'filterResultText'] = opts[:'filter_result_text'] if !opts[:'filter_result_text'].nil?
      query_params[:'sortField'] = opts[:'sort_field'] if !opts[:'sort_field'].nil?
      query_params[:'sortOrder'] = opts[:'sort_order'] if !opts[:'sort_order'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Recipients' 

      auth_names = opts[:auth_names] || ['ApiAuthKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RecipientsApi#get_recipients\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
